'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var system = require('@chakra-ui/system');
var utils = require('@chakra-ui/utils');
var React = require('react');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n["default"] = e;
  return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

var _excluded = ["id"],
    _excluded2 = ["id"];
var fallbackId = "chakra-skip-nav";
var baseStyle = {
  userSelect: "none",
  border: "0",
  height: "1px",
  width: "1px",
  margin: "-1px",
  padding: "0",
  outline: "0",
  overflow: "hidden",
  position: "absolute",
  clip: "rect(0 0 0 0)",
  _focus: {
    clip: "auto",
    width: "auto",
    height: "auto"
  }
};
/**
 * Renders a link that remains hidden until focused to skip to the main content.
 */

var SkipNavLink = /*#__PURE__*/system.forwardRef(function (props, ref) {
  var styles = system.useStyleConfig("SkipLink", props);

  var _omitThemingProps = system.omitThemingProps(props),
      _omitThemingProps$id = _omitThemingProps.id,
      id = _omitThemingProps$id === void 0 ? fallbackId : _omitThemingProps$id,
      rest = _objectWithoutPropertiesLoose(_omitThemingProps, _excluded);

  var linkStyles = utils.mergeWith({}, baseStyle, styles);
  return /*#__PURE__*/React__namespace.createElement(system.chakra.a, _extends({}, rest, {
    ref: ref,
    href: "#" + id,
    __css: linkStyles
  }));
});

if (utils.__DEV__) {
  SkipNavLink.displayName = "SkipNavLink";
}

/**
 * Renders a div as the target for the link.
 */
var SkipNavContent = /*#__PURE__*/system.forwardRef(function (props, ref) {
  var _props$id = props.id,
      id = _props$id === void 0 ? fallbackId : _props$id,
      rest = _objectWithoutPropertiesLoose(props, _excluded2);

  return /*#__PURE__*/React__namespace.createElement(system.chakra.div, _extends({
    ref: ref,
    id: id,
    tabIndex: -1,
    style: {
      outline: 0
    }
  }, rest));
});

if (utils.__DEV__) {
  SkipNavContent.displayName = "SkipNavContent";
}

exports.SkipNavContent = SkipNavContent;
exports.SkipNavLink = SkipNavLink;
